//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  dcr (R|[lg̃ACR\[X) t@Crbg}bv擾
//  DLLɂĎ擾@
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N1124 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    Image1: TImage;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FdcrDllFile : string;
    function dcrToDllFile(AdcrFilePath: string): string;
  public
    { Public 錾 }
  end;

function EnumResNameProc(hModule: HWND; lpszType: PChar; lpszName:PChar;
  AIndex: LPARAM): LongBool; stdcall;

var
  Form1: TForm1;

implementation

uses
  ShellAPI,
  StrUtils;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := '.\plPrevReg.dcr';
  Image1.AutoSize :=True;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
var
  LdprFile : string;
  LresFile : string;
begin
  LdprFile := ChangeFileExt(FdcrDllFile, '.dpr');
  LresFile := ChangeFileExt(FdcrDllFile, '.res');
  DeleteFile(FdcrDllFile);
  DeleteFile(LdprFile);
  DeleteFile(LresFile);
end;

//=============================================================================
//  \[X̗
//  ł RT_BITMAP Ƃ(܂rbg}bv)
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LdcrFilePath : string;
  LhModule     : THandle;
  LdwFlag      : Cardinal;
begin
  Image1.Picture.Assign(nil);
  if FdcrDllFile <> '' then FormDestroy(nil);

  LdcrFilePath := ExpandFileName(Trim(Edit1.Text));
  FdcrDllFile  := dcrToDllFile(LdcrFilePath);

  ListBox1.Items.Clear;
  ListBox1.Items.BeginUpdate;

  if FdcrDllFile <> '' then begin
    //DLLt@Cw肵ăW[̃nh擾
    LdwFlag     := LOAD_LIBRARY_AS_DATAFILE or LOAD_WITH_ALTERED_SEARCH_PATH;
    LhModule    := LoadLibraryEx(PChar(FdcrDllFile), 0, LdwFlag);
    try
     if LhModule <> 0 then begin
       //\[XID
       EnumResourceNames(LhModule, RT_BITMAP, @EnumResNameProc, -1);
     end;
     Label1.Caption := IntToStr(ListBox1.Items.Count);
    finally
      FreeLibrary(LhModule);
    end;
  end;
  ListBox1.Items.EndUpdate;
end;

//=============================================================================
//  ListBox1OnClickCxg
//  Xg{bNXItemNbN炻̃\[XǂݏoTImageɕ\
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
var
  LdwFlag  : Cardinal;
  LhModule : THandle;
  LItemStr : string;
  LItemInt : Integer;
  LBitmap  : TBitmap;
begin
  Image1.Picture.Assign(nil);@
  if ListBox1.ItemIndex =-1 then Exit;

  //\[Xt@Cw肵ăW[̃nh擾
  LdwFlag  := LOAD_LIBRARY_AS_DATAFILE or LOAD_WITH_ALTERED_SEARCH_PATH;
  LhModule := LoadLibraryEx(PChar(FdcrDllFile), 0, LdwFlag);
  try
  @if LhModule <> 0 then begin
      LBitmap := TBitmap.Create;
      try
        LItemStr := ListBox1.Items[ListBox1.ItemIndex];
        LItemInt := StrToIntDef(LItemStr, -1);

        //\[XIDl̎ƕ̎ŏ𕪊
        //񂪐ō\ĂƐlƔ肵Ă܂
        if LItemInt < 0 then begin
          LBitmap.LoadFromResourceName(LhModule, LItemStr);;
        end else begin
          LBitmap.LoadFromResourceID(LhModule, LItemInt);
        end;

        Image1.Picture.Bitmap.Assign(LBitmap);
      finally
        //LBitmap.HandleHBitmapĂ̂DeleteObject(LhBitmap)͕sv
        FreeAndNil(LBitmap);
      end;
    end;
  finally
    FreeLibrary(LhModule);
  end;
end;

//-----------------------------------------------------------------------------
//  EnumResourceNames̃R[obN֐
//  \[X̗
//-----------------------------------------------------------------------------
function EnumResNameProc(hModule: HWND; lpszType: PChar; lpszName: PChar;
  AIndex: LPARAM): LongBool;
var
  LhBitmap  : HBitmap;
  LResIDStr : string;
begin
  Result := True;

  if AIndex = -1 then begin
    //\[X̎擾
    LhBitmap := LoadImage(hModule, MakeIntResource(lpszName), IMAGE_BITMAP, 0, 0, 0);
    try
      if LhBitmap <> 0 then begin

        //\[X̃`FbN
        //WORD(2oCg) 0ȂID͐l.ȊÕ͕|C^
        if HiWord(Cardinal(lpszName)) = 0 then begin
          LResIDStr := IntToStr(Cardinal(lpszName));
        end else begin
          LResIDStr := lpszName;
        end;

        //\[XIDXgɒǉ
        Form1.ListBox1.Items.Add(LResIDStr);
      end;
    finally
      DeleteObject(LhBitmap);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  gqdcr̃t@Cdllt@C쐬֐
//  sDelphiCXg[ĂKv
//
//  AdcrFilePath : Ώۂdcrt@C̃tpX
//  ߂ldll̃pXDsƋ󕶎Ԃ
//  O[oȕϐ͎gpĂȂ
//
//  uses  ShellAPI,StrUtilsKv
//-----------------------------------------------------------------------------
function TForm1.dcrToDllFile(AdcrFilePath: string): string;
var
  LSelfAppPath   : string;
  LResFilePath   : string;
  LdprFilePath   : string;
  LdprCodeList   : TStringList;
  Lpdcc32ExePath : PChar;
  Ldcc32ExePath  : string;
  LCompilerName  : string;
  LCmdLineStr    : string;
  LStartInfo     : TStartupInfo;
  LProcessInfo   : TProcessInformation;
begin
  Result := '';

  //res,dpr̃pX𐶐
  LSelfAppPath := ExtractFilePath(Application.ExeName);
  LResFilePath := LSelfAppPath + ChangeFileExt(ExtractFileName(AdcrFilePath), '.res');
  LdprFilePath := LSelfAppPath + ChangeFileExt(ExtractFileName(AdcrFilePath), '.dpr');

  DeleteFile(LResFilePath);
  DeleteFile(LdprFilePath);
  //rest@Cۑ
  CopyFile(PChar(AdcrFilePath), PChar(LResFilePath), False);

  //DLL쐬p̃vWFNgR[h쐬ĕۑ
  LdprCodeList := TStringList.Create;
  try
    LdprCodeList.Add('library ' + ChangeFileExt(ExtractFileName(LdprFilePath), '') + ';');
    LdprCodeList.Add('uses Windows;');
    LdprCodeList.Add('{$R '+ ExtractFileName(LResFilePath) + '}');
    LdprCodeList.Add('begin');
    LdprCodeList.Add('end.');
    LdprCodeList.SaveToFile(LdprFilePath);
  finally
    FreeAndNil(LdprCodeList);
  end;

  //R}hCRpC(dcc32.exe)̃tpX擾
  Lpdcc32ExePath := StrAlloc(MAX_PATH + 1);
  try
    if FindExecutable(PChar(LdprFilePath), nil, Lpdcc32ExePath) > 32 then begin
      Ldcc32ExePath := Lpdcc32ExePath;
      if Ldcc32ExePath <> '' then begin
        LCompilerName := ExtractFileName(Ldcc32ExePath);
        Ldcc32ExePath := ReplaceText(Ldcc32ExePath, LCompilerName, 'dcc32.exe');
      end;
    end else begin
      exit;
    end;
  finally
    StrDispose(Lpdcc32ExePath);
  end;
  if LowerCase(ExtractFileName(Ldcc32ExePath)) <> 'dcc32.exe' then exit;

  Ldcc32ExePath := AnsiQuotedStr(Trim(Ldcc32ExePath), '"');
  //쐬vWFNgt@CRpCDLL쐬
  GetStartupInfo(LStartInfo);
  LStartInfo.dwXSize := 0;
  LStartInfo.dwYSize := 0;
  LStartInfo.wShowWindow := SW_HIDE;

  LCmdLineStr := Ldcc32ExePath + ' ' + AnsiQuotedStr(LdprFilePath,'"');
  UniqueString(LCmdLineStr);
  if not CreateProcess(nil,
                       PChar(LCmdLineStr),
                       nil,
                       nil,
                       False,
                       0,
                       nil,
                       PChar(LSelfAppPath),
                       LStartInfo,
                       LProcessInfo) then begin
  end else begin
    //RpCI܂ő҂
    while WaitForSingleObject(LProcessInfo.hProcess, 0) = WAIT_TIMEOUT do begin
      Application.ProcessMessages;
      Sleep(1);
    end;
    CloseHandle(LProcessInfo.hProcess);
    CloseHandle(LProcessInfo.hThread);

    Result := ChangeFileExt(LdprFilePath, '.dll');
  end;
end;

end.
